
use strict;

sub zero_all;
sub tpwc($);

my %counts;

my @tp_letters = split( //, 'aeioumnljwktps' );

print scalar( @tp_letters ) . "\n";   	 ###DEBUG

=pod test routine
my $i = 0;
for ( $i = 0; $i <= 30; $i++ ) {
    print &tpwc( $i ) . "\n";
}
=cut


my $sentence_template = q("kulupu nimi ni li jo " .
			  "e sitelen lili 'a' " . &tpwc($counts{'a'}) . 
			  " e sitelen lili 'e' " . &tpwc($counts{'e'}) .
			  " e sitelen lili 'i' " . &tpwc($counts{'i'}) .
			  " e sitelen lili 'o' " . &tpwc($counts{'o'}) .
			  " e sitelen lili 'u' " . &tpwc($counts{'u'}) .
			  " e sitelen lili 'k' " . &tpwc($counts{'k'}) .
			  " e sitelen lili 't' " . &tpwc($counts{'t'}) . 
			  " e sitelen lili 'p' " . &tpwc($counts{'p'}) .
			  " e sitelen lili 's' " . &tpwc($counts{'s'}) .
			  " e sitelen lili 'm' " . &tpwc($counts{'m'}) .
			  " e sitelen lili 'n' " . &tpwc($counts{'n'}) .
			  " e sitelen lili 'j' " . &tpwc($counts{'j'}) .
			  " e sitelen lili 'w' " . &tpwc($counts{'w'}) .
			  " e sitelen lili 'l' " . &tpwc($counts{'l'}) . "." );

my @false_sentences;

my $done = 0;

&zero_all;
my $working_sentence = eval( $sentence_template );
my $last_sentence = "";
my $n = 0;  # iterations

while ( ! $done && $n < 1000 ) {
    print ++$n . ": " . $working_sentence . "\n\n";
    $last_sentence = $working_sentence;
    &zero_all;
    my @letters = split( //, $working_sentence );
    foreach ( @letters ) {
	$counts{ $_ }++;
    }
    $working_sentence = eval( $sentence_template );

    if ( $working_sentence eq $last_sentence ) {
	$done = 1;
    } else { 
	push @false_sentences, $working_sentence;
    }
}

if ( $done ) {
    print "\nFound true sentence:\n\n" . $working_sentence . "\n\n";

    foreach( keys %counts ) {
	print "\t" . $_ . ": " . $counts{ $_ } . "\n";
    }
}



sub zero_all {
	$counts{'a'} = 0;
	$counts{'e'} = 0;
	$counts{'i'} = 0;
	$counts{'o'} = 0;
	$counts{'u'} = 0;
	$counts{'k'} = 0;
	$counts{'t'} = 0;
	$counts{'p'} = 0;
	$counts{'s'} = 0;
	$counts{'m'} = 0;
	$counts{'n'} = 0;
	$counts{'l'} = 0;
	$counts{'j'} = 0;
	$counts{'w'} = 0;
}


sub tpwc($) {
    my $arg = shift;
    my $numberphrase = "";

    if ( $arg == 0 ) {
	return "ala";
    }
     
    while ( $arg > 0 ) {
	if ($arg >= 5 ) {
	    $numberphrase .= "luka ";
	    $arg -= 5;
	} elsif ( $arg >= 2 ) {
	    $numberphrase .= "tu ";
	    $arg -= 2;
	} else {
	    $numberphrase .= "wan ";
	    $arg -= 1;
	}
    }
    $numberphrase =~ s/ +$//;
    
    return $numberphrase;
}
